From 3c5df36904c8a5e9137a90309795b3eb9f90dd73 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Adri=C3=A0=20Garriga-Alonso?= <adria.garriga@gmail.com>
Date: Wed, 4 Sep 2019 11:36:48 +0100
Subject: [PATCH] cl-reduce avoids calling the function when list is nil

---
 lisp/emacs-lisp/cl-seq.el            | 31 ++++++++++++++--------------
 test/lisp/emacs-lisp/cl-seq-tests.el |  6 ++++++
 2 files changed, 22 insertions(+), 15 deletions(-)

diff --git a/lisp/emacs-lisp/cl-seq.el b/lisp/emacs-lisp/cl-seq.el
index a15c994bc1..8da6ec5a2a 100644
--- a/lisp/emacs-lisp/cl-seq.el
+++ b/lisp/emacs-lisp/cl-seq.el
@@ -134,21 +134,22 @@ If SEQ is empty, return :INITIAL-VALUE and FUNCTION is not
 called.
 
 \n(fn FUNCTION SEQ [KEYWORD VALUE]...)"
-  (cl--parsing-keywords (:from-end (:start 0) :end :initial-value :key) ()
-    (or (listp cl-seq) (setq cl-seq (append cl-seq nil)))
-    (setq cl-seq (cl-subseq cl-seq cl-start cl-end))
-    (if cl-from-end (setq cl-seq (nreverse cl-seq)))
-    (let ((cl-accum (cond ((memq :initial-value cl-keys) cl-initial-value)
-			  (cl-seq (cl--check-key (pop cl-seq)))
-			  (t (funcall cl-func)))))
-      (if cl-from-end
-	  (while cl-seq
-	    (setq cl-accum (funcall cl-func (cl--check-key (pop cl-seq))
-				    cl-accum)))
-	(while cl-seq
-	  (setq cl-accum (funcall cl-func cl-accum
-				  (cl--check-key (pop cl-seq))))))
-      cl-accum)))
+   (when cl-seq
+    (cl--parsing-keywords (:from-end (:start 0) :end :initial-value :key) ()
+      (or (listp cl-seq) (setq cl-seq (append cl-seq nil)))
+      (setq cl-seq (cl-subseq cl-seq cl-start cl-end))
+      (if cl-from-end (setq cl-seq (nreverse cl-seq)))
+      (let ((cl-accum (cond ((memq :initial-value cl-keys) cl-initial-value)
+                            (cl-seq (cl--check-key (pop cl-seq)))
+                            (t (funcall cl-func)))))
+        (if cl-from-end
+            (while cl-seq
+              (setq cl-accum (funcall cl-func (cl--check-key (pop cl-seq))
+                                      cl-accum)))
+          (while cl-seq
+            (setq cl-accum (funcall cl-func cl-accum
+                                    (cl--check-key (pop cl-seq))))))
+        cl-accum))))
 
 ;;;###autoload
 (defun cl-fill (cl-seq cl-item &rest cl-keys)
diff --git a/test/lisp/emacs-lisp/cl-seq-tests.el b/test/lisp/emacs-lisp/cl-seq-tests.el
index 6515eee9f2..56c1826483 100644
--- a/test/lisp/emacs-lisp/cl-seq-tests.el
+++ b/test/lisp/emacs-lisp/cl-seq-tests.el
@@ -311,5 +311,11 @@ Body are forms defining the test."
       (should (eq (cl-assoc x a) (car a)))
       (should (eq (cl-rassoc x a) (cadr a))))))
 
+(ert-deftest cl-seq-reduce ()
+  (let ((bad-add (lambda (x y) (+ x y))))
+    (should-not (cl-reduce bad-add nil))
+    (should (equal 1 (cl-reduce bad-add '(1))))
+    (should (equal 3 (cl-reduce bad-add '(1 2))))))
+
 (provide 'cl-seq-tests)
 ;;; cl-seq-tests.el ends here
-- 
2.21.0

